/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreLogic.TCoreLogicPath;
import de.ship.db.tables.TCoreLogicandgrp.TCoreLogicandgrpPath;
import de.ship.db.tables.records.TCoreLogicorgrpRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogicorgrp extends TableImpl<TCoreLogicorgrpRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logicorgrp</code>
     */
    public static final TCoreLogicorgrp T_CORE_LOGICORGRP = new TCoreLogicorgrp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogicorgrpRecord> getRecordType() {
        return TCoreLogicorgrpRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logicorgrp.lastchange</code>.
     */
    public final TableField<TCoreLogicorgrpRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_logicorgrp.orgrp</code>. id of logical
     * or group
     */
    public final TableField<TCoreLogicorgrpRecord, Integer> ORGRP = createField(DSL.name("orgrp"), SQLDataType.INTEGER.nullable(false), this, "id of logical or group");

    private TCoreLogicorgrp(Name alias, Table<TCoreLogicorgrpRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogicorgrp(Name alias, Table<TCoreLogicorgrpRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logicorgrp</code> table
     * reference
     */
    public TCoreLogicorgrp(String alias) {
        this(DSL.name(alias), T_CORE_LOGICORGRP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logicorgrp</code> table
     * reference
     */
    public TCoreLogicorgrp(Name alias) {
        this(alias, T_CORE_LOGICORGRP);
    }

    /**
     * Create a <code>common_dd.t_core_logicorgrp</code> table reference
     */
    public TCoreLogicorgrp() {
        this(DSL.name("t_core_logicorgrp"), null);
    }

    public <O extends Record> TCoreLogicorgrp(Table<O> path, ForeignKey<O, TCoreLogicorgrpRecord> childPath, InverseForeignKey<O, TCoreLogicorgrpRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGICORGRP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogicorgrpPath extends TCoreLogicorgrp implements Path<TCoreLogicorgrpRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogicorgrpPath(Table<O> path, ForeignKey<O, TCoreLogicorgrpRecord> childPath, InverseForeignKey<O, TCoreLogicorgrpRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogicorgrpPath(Name alias, Table<TCoreLogicorgrpRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogicorgrpPath as(String alias) {
            return new TCoreLogicorgrpPath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogicorgrpPath as(Name alias) {
            return new TCoreLogicorgrpPath(alias, this);
        }

        @Override
        public TCoreLogicorgrpPath as(Table<?> alias) {
            return new TCoreLogicorgrpPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TCoreLogicorgrpRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGICORGRP;
    }

    private transient TCoreLogicPath _tCoreLogic;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logic</code> table
     */
    public TCoreLogicPath tCoreLogic() {
        if (_tCoreLogic == null)
            _tCoreLogic = new TCoreLogicPath(this, null, Keys.T_CORE_LOGIC__FK_LOGIC_ORGRP.getInverseKey());

        return _tCoreLogic;
    }

    private transient TCoreLogicandgrpPath _tCoreLogicandgrp;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logicandgrp</code> table
     */
    public TCoreLogicandgrpPath tCoreLogicandgrp() {
        if (_tCoreLogicandgrp == null)
            _tCoreLogicandgrp = new TCoreLogicandgrpPath(this, null, Keys.T_CORE_LOGICANDGRP__FK_AND_ORGRP.getInverseKey());

        return _tCoreLogicandgrp;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        return tCoreLogic().tCoreElementHierarchy();
    }

    @Override
    public TCoreLogicorgrp as(String alias) {
        return new TCoreLogicorgrp(DSL.name(alias), this);
    }

    @Override
    public TCoreLogicorgrp as(Name alias) {
        return new TCoreLogicorgrp(alias, this);
    }

    @Override
    public TCoreLogicorgrp as(Table<?> alias) {
        return new TCoreLogicorgrp(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicorgrp rename(String name) {
        return new TCoreLogicorgrp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicorgrp rename(Name name) {
        return new TCoreLogicorgrp(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicorgrp rename(Table<?> name) {
        return new TCoreLogicorgrp(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicorgrp where(Condition condition) {
        return new TCoreLogicorgrp(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicorgrp where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicorgrp where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicorgrp where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicorgrp where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicorgrp where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicorgrp where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicorgrp where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicorgrp whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicorgrp whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
